#ifndef ASSERT_H
#define ASSERT_H
    
    #include "common.h"
    
    #ifdef NDEBUG
        #define assert(x) do{}while(0)
    #else
        extern void assertTrace(const char *assertion, const char *file, const char *function, unsigned int line);
        #define assert(x) do{if(!(x))assertTrace(#x,__FILE__,__PRETTY_FUNCTION__,__LINE__);}while(0)
    #endif
    
#endif
